/// <reference path="../../../../../types/@react-navigation/core.d.ts" />
/// <reference path="../../../../../types/@react-navigation/native.d.ts" />
import * as React from 'react';
import { NavigationRoute } from 'react-navigation';
import { NavigationStackProp, NavigationStackConfig, SceneDescriptorMap } from '../../types';
declare type Props = {
    navigation: NavigationStackProp;
    descriptors: SceneDescriptorMap;
    navigationConfig: NavigationStackConfig;
    onPageChangeStart?: () => void;
    onPageChangeConfirm?: () => void;
    onPageChangeCancel?: () => void;
    screenProps?: unknown;
};
declare type State = {
    routes: NavigationRoute[];
    previousRoutes: NavigationRoute[];
    openingRouteKeys: string[];
    closingRouteKeys: string[];
    replacingRouteKeys: string[];
    descriptors: SceneDescriptorMap;
};
declare class StackView extends React.Component<Props, State> {
    static getDerivedStateFromProps(props: Readonly<Props>, state: Readonly<State>): {
        routes: NavigationRoute<import("react-navigation").NavigationParams>[];
        previousRoutes: NavigationRoute<import("react-navigation").NavigationParams>[];
        openingRouteKeys: string[];
        closingRouteKeys: string[];
        replacingRouteKeys: string[];
        descriptors: SceneDescriptorMap;
    } | null;
    state: State;
    private getGesturesEnabled;
    private getPreviousRoute;
    private renderScene;
    private renderHeader;
    private handleTransitionComplete;
    private handleGoBack;
    private handleOpenRoute;
    private handleCloseRoute;
    render(): JSX.Element;
}
export default StackView;
